    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.flow.planner.process;
    022
    023import java.util.Set;
    024
    025import cascading.flow.FlowElement;
    026import cascading.flow.planner.graph.ElementGraph;
    027import cascading.flow.planner.graph.ElementGraphs;
    028import cascading.util.Util;
    029
    030/**
    031 *
    032 */
    033public class ProcessModels
    034  {
    035  /**
    036   * Does the given process perform any work?
    037   *
    038   * @param process
    039   * @param excludingType
    040   * @return
    041   */
    042  public static boolean isIdentity( ProcessModel process, Class<? extends FlowElement> excludingType )
    043    {
    044    ElementGraph elementGraph = ElementGraphs.asExtentMaskedSubGraph( process.getElementGraph() );
    045
    046    Set<? extends FlowElement> sourceElements = Util.narrowIdentitySet( excludingType, process.getSourceElements(), false );
    047    Set<? extends FlowElement> sinkElements = Util.narrowIdentitySet( excludingType, process.getSinkElements(), false );
    048
    049    return elementGraph.vertexSet().size() == ( sourceElements.size() + sinkElements.size() );
    050    }
    051
    052  /**
    053   * Does the given process perform any work?
    054   *
    055   * @param process
    056   * @return
    057   */
    058  public static boolean isIdentity( ProcessModel process )
    059    {
    060    ElementGraph elementGraph = ElementGraphs.asExtentMaskedSubGraph( process.getElementGraph() );
    061
    062    Set<FlowElement> sourceElements = process.getSourceElements();
    063    Set<FlowElement> sinkElements = process.getSinkElements();
    064
    065    return elementGraph.vertexSet().size() == ( sourceElements.size() + sinkElements.size() );
    066    }
    067  }